VERSION 4.00
Begin VB.Form PictureViewerForm 
   Caption         =   "Picture Viewer"
   ClientHeight    =   3930
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4335
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   3930
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.ComboBox cboPatterns 
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Text            =   "cboPatterns"
      Top             =   3600
      Width           =   2175
   End
   Begin VB.DriveListBox drvDrives 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox dirDirectories 
      Height          =   1155
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.FileListBox filFiles 
      Height          =   2010
      Left            =   0
      TabIndex        =   0
      Top             =   1560
      Width           =   2175
   End
   Begin VB.Image imgView 
      Height          =   735
      Left            =   2280
      Top             =   0
      Width           =   855
   End
End
Attribute VB_Name = "PictureViewerForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' The user has picked a new directory.
' Update the file list.
Private Sub dirDirectories_Change()
    filFiles.Path = dirDirectories.Path
End Sub

' The user has picked a new drive.
' Update the directory list.
Private Sub drvDrives_Change()
    dirDirectories.Path = drvDrives.Drive
End Sub

' The user has picked a file.
' Display it.
Private Sub filFiles_Click()
Dim fname As String

    ' Display the selected file's full name
    ' in the form's caption.
    fname = filFiles.Path + "\" + filFiles.filename
    Caption = "Picture Viewer [" & fname & "]"

    ' Display the picture.
    MousePointer = vbHourglass
    DoEvents
    imgView.Picture = LoadPicture(fname)
    MousePointer = vbDefault
End Sub

' Load cboPatterns with file selection patterns.
Private Sub Form_Load()
    cboPatterns.AddItem "Bitmaps (*.bmp)"
    cboPatterns.AddItem "GIF (*.gif)"
    cboPatterns.AddItem "JPEG (*.jpg)"
    cboPatterns.AddItem "Graphic (*.bmp;*.gif;*.jpg)"
    cboPatterns.AddItem "All Files (*.*)"

    ' Start with the first choice (bitmaps) selected.
    cboPatterns.ListIndex = 0
End Sub

' Make the controls as big as possible.
Private Sub Form_Resize()
Const GAP = 60

Dim wid As Integer
Dim hgt As Integer

    ' Put drvDrives at the top.
    wid = drvDrives.Width
    drvDrives.Move GAP, GAP, wid

    ' Put cboPatterns at the bottom.
    cboPatterns.Move GAP, ScaleHeight - cboPatterns.Height, wid

    ' Make dirDirectories and filFiles split the
    ' rest of the available height.
    hgt = (cboPatterns.Top - drvDrives.Top - drvDrives.Height - 3 * GAP) / 2
    dirDirectories.Move GAP, drvDrives.Top + drvDrives.Height + GAP, wid, hgt
    filFiles.Move GAP, dirDirectories.Top + dirDirectories.Height + GAP, wid, hgt
End Sub

' The user selected a new pattern.
' Make filFiles use the selected pattern to list files.
Private Sub cboPatterns_Click()
Dim choice As String
Dim file_pattern As String
Dim start_pos As Integer
Dim end_pos As Integer
    
    ' Find the pattern between parentheses.
    choice = cboPatterns.List(cboPatterns.ListIndex)
    start_pos = InStr(choice, "(")
    end_pos = InStr(choice, ")")
    file_pattern = Mid$(choice, start_pos + 1, _
        end_pos - start_pos - 1)

    filFiles.Pattern = file_pattern
End Sub

