VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PersonStack"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' File: Person.cls
Option Explicit

' UDT to represent a person.
Private Type Person
    perLastName As String
    perFirstName As String
End Type

' The stack array.
Private NumPeople As Integer
Private People() As Person
' Add a person to the stack.
Public Sub Push(ByVal last_name As String, ByVal first_name As String)
    ' Update the number of people.
    NumPeople = NumPeople + 1

    ' Create space for the new person.
    ReDim Preserve People(1 To NumPeople)

    ' Save the new person's data.
    With People(NumPeople)
        .perLastName = last_name
        .perFirstName = first_name
    End With
End Sub
' Return the number of people in the stack.
Public Property Get NumPersons() As Integer
    NumPersons = NumPeople
End Property

' Remove the top person from the stack. Return
' that person's data through parameters.
Public Sub Pop(last_name As String, first_name As String)
    ' Get the last person's data.
    With People(NumPeople)
        last_name = .perLastName
        first_name = .perFirstName
    End With

    ' Update the number of people.
    NumPeople = NumPeople - 1

    ' Remove the last person.
    If NumPeople > 0 Then
        ReDim Preserve People(1 To NumPeople)
    Else
        Erase People
    End If
End Sub

' Return a textual representation of the stack.
Public Function TextRepresentation() As String
Dim i As Integer
Dim txt As String

    For i = 1 To NumPeople
        With People(i)
            txt = .perLastName & ", " & _
                .perFirstName & _
                vbCrLf & txt
        End With
    Next i

    TextRepresentation = txt
End Function

