VERSION 4.00
Begin VB.Form PictureViewerForm 
   Caption         =   "Picture Viewer"
   ClientHeight    =   3930
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4335
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   3930
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.ComboBox cboPatterns 
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Text            =   "cboPatterns"
      Top             =   3600
      Width           =   2175
   End
   Begin VB.DriveListBox drvDrives 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox dirDirectories 
      Height          =   1155
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.FileListBox filFiles 
      Height          =   2010
      Left            =   0
      TabIndex        =   0
      Top             =   1560
      Width           =   2175
   End
   Begin VB.Image imgView 
      Height          =   735
      Left            =   2280
      Top             =   0
      Width           =   855
   End
End
Attribute VB_Name = "PictureViewerForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Set to False in the compiled version.
Private Const DEBUG_MODE = True
' The user has picked a new directory.
' Update the file list.
Private Sub dirDirectories_Change()
    On Error GoTo DirectoryError

    filFiles.Path = dirDirectories.Path
    Exit Sub

DirectoryError:
    ' There are no known ways this routine can fail.
    ' At design time, stop so we can fix the bug.
    ' In the compiled version, continue.
    If DEBUG_MODE Then Stop
    Resume Next
End Sub

' The user has picked a new drive.
' Update the directory list.
Private Sub drvDrives_Change()
    On Error GoTo DriveError
    
    dirDirectories.Path = drvDrives.Drive
    Exit Sub

DriveError:
    If MsgBox("Drive " & drvDrives.Drive & _
        " is unavailable. Try again?", _
        vbRetryCancel, "Drive Unavailable") _
        = vbRetry _
    Then
        ' Try again. The user may have inserted
        ' a missing floppy disk or CD-ROM.
        Resume
    End If
    
    ' Keep the previously selected drive.
    drvDrives.Drive = dirDirectories.Path
    Exit Sub
End Sub

' The user has picked a file.
' Display it.
Private Sub filFiles_Click()
Dim fname As String

    On Error GoTo LoadPictureError

    ' Display the selected file's full name
    ' in the form's caption.
    fname = filFiles.Path
    If Right$(fname, 1) <> "\" Then fname = fname & "\"
    fname = fname & filFiles.filename
    Caption = "Picture Viewer [" & fname & "]"

    ' Display the picture.
    MousePointer = vbHourglass
    DoEvents
    imgView.Picture = LoadPicture(fname)
    MousePointer = vbDefault
    Exit Sub

LoadPictureError:
    If Err.Number = 481 Then
        ' The picture failed to load. This is an
        ' expected error but not a bug. Let the user know
        ' the file could not be loaded and continue.
        Beep
        Caption = "Picture Viewer [Invalid picture]"
        Set imgView.Picture = Nothing
    Else
        ' This is an unknown error.
        ' There are no other known ways this routine can fail.
        ' At design time, stop so we can fix the bug.
        ' In the compiled version, continue.
        If DEBUG_MODE Then Stop
    End If
    
    ' Among other things, the Resume Next lets the
    ' code continue until it resets the cursor with:
    '    MousePointer = vbDefault
    Resume Next
End Sub

' Load cboPatterns with file selection patterns.
Private Sub Form_Load()
    On Error GoTo LoadError
    
    cboPatterns.AddItem "Bitmaps (*.bmp)"
    cboPatterns.AddItem "GIF (*.gif)"
    cboPatterns.AddItem "JPEG (*.jpg)"
    cboPatterns.AddItem "Graphic (*.bmp;*.gif;*.jpg)"
    cboPatterns.AddItem "All Files (*.*)"

    ' Start with the first choice (bitmaps) selected.
    cboPatterns.ListIndex = 0
    Exit Sub

LoadError:
    ' There are no known ways this routine can fail.
    ' At design time, stop so we can fix the bug.
    ' In the compiled version, continue.
    If DEBUG_MODE Then Stop
    Resume Next
End Sub

' Make the controls as big as possible.
Private Sub Form_Resize()
Const GAP = 60

Dim wid As Integer
Dim hgt As Integer

    On Error GoTo ResizeError

    ' Do nothing if the form is minimized.
    If WindowState = vbMinimized Then Exit Sub

    ' Put drvDrives at the top.
    wid = drvDrives.Width
    drvDrives.Move GAP, GAP, wid

    ' Put cboPatterns at the bottom.
    cboPatterns.Move GAP, ScaleHeight - cboPatterns.Height, wid

    ' Make dirDirectories and filFiles split the
    ' rest of the available height.
    hgt = (cboPatterns.Top - drvDrives.Top - drvDrives.Height - 3 * GAP) / 2
    If hgt < 100 Then hgt = 100
    dirDirectories.Move GAP, drvDrives.Top + drvDrives.Height + GAP, wid, hgt
    filFiles.Move GAP, dirDirectories.Top + dirDirectories.Height + GAP, wid, hgt
    Exit Sub

ResizeError:
    ' There are no known ways this routine can fail.
    ' At design time, stop so we can fix the bug.
    ' In the compiled version, continue.
    If DEBUG_MODE Then Stop
    Resume Next
End Sub

' The user selected a new pattern.
' Make filFiles use the selected pattern to list files.
Private Sub cboPatterns_Click()
Dim choice As String
Dim file_pattern As String
Dim start_pos As Integer
Dim end_pos As Integer
    
    On Error GoTo NewPatternError
    
    ' Find the pattern between parentheses.
    choice = cboPatterns.List(cboPatterns.ListIndex)
    start_pos = InStr(choice, "(")
    end_pos = InStr(choice, ")")
    file_pattern = Mid$(choice, start_pos + 1, _
        end_pos - start_pos - 1)

    filFiles.Pattern = file_pattern
    Exit Sub

NewPatternError:
    ' There are no known ways this routine can fail.
    ' At design time, stop so we can fix the bug.
    ' In the compiled version, continue.
    If DEBUG_MODE Then Stop
    Resume Next
End Sub


