Attribute VB_Name = "DBErr"
Option Explicit

' Create a new error record in the error database.
Public Sub SaveErrorToDatabase(ByVal routine_name As String)
Dim txt1 As String
Dim txt2 As String
Dim error_database As Database
Dim database_open As Boolean
Dim database_name As String

    ' Create the error message.
    txt1 = MakeErrorMessage(routine_name)

    On Error GoTo SaveErrorToDatabaseError

    ' Open the database.
    database_name = App.Path
    If Right$(database_name, 1) <> "\" _
        Then database_name = database_name & "\"
    database_name = database_name & "errors.mdb"
    Set error_database = OpenDatabase(database_name)

    ' Remember that the database is open.
    database_open = True

    ' Save the new information.
    error_database.Execute _
        "INSERT INTO AutoErrors VALUES(" & _
        "Now, '" & txt1 & "')"

    ' Close the database.
    error_database.Close
    Exit Sub

SaveErrorToDatabaseError:
    ' There was an error saving to the file.
    ' Just present the message.
    txt2 = MakeErrorMessage("SaveErrorToDatabase")
    MsgBox "Error saving error message to database." & _
        vbCrLf & _
        "Please record the following information " & _
        "and send it to the development team:" & _
        vbCrLf & vbCrLf & txt2 & _
        vbCrLf & vbCrLf & txt1

    ' Close the database if we opened it.
    If database_open Then error_database.Close
    Exit Sub
End Sub
' Make an appropriate error message.
Public Function MakeErrorMessage(ByVal routine_name As String) As String
    MakeErrorMessage = _
        "Unexpected error " & _
        Format$(Err.Number) & _
        " in " & routine_name & "." & _
        vbCrLf & Err.Description
End Function
