Attribute VB_Name = "FileErr"
Option Explicit

' Make an appropriate error message.
Public Function MakeErrorMessage(ByVal routine_name As String) As String
    MakeErrorMessage = _
        "Unexpected error " & _
        Format$(Err.Number) & _
        " in " & routine_name & "." & _
        vbCrLf & Err.Description
End Function

' Append mail to an error log file.
Public Sub SaveErrorToFile(ByVal routine_name As String)
Dim txt1 As String
Dim txt2 As String
Dim file_name As String
Dim fnum As Integer
Dim file_open As Boolean

    ' Create the error message.
    txt1 = MakeErrorMessage(routine_name)

    On Error GoTo SaveErrorToFileError

    ' Open the file.
    fnum = FreeFile
    file_name = App.Path
    If Right$(file_name, 1) <> "\" _
        Then file_name = file_name & "\"
    file_name = file_name & "errors.log"
    Open file_name For Append As #fnum

    ' Remember that the file is open.
    file_open = True

    ' Write the date and time, and the error message.
    Print #fnum, Now
    Print #fnum, txt1
    Print #fnum, "**********"

    ' Close the file.
    Close #fnum
    Exit Sub

SaveErrorToFileError:
    ' There was an error saving to the file.
    ' Just present the message.
    txt2 = MakeErrorMessage("SaveErrorToFile")
    MsgBox "Error saving error message to file." & _
        vbCrLf & _
        "Please record the following information " & _
        "and send it to the development team:" & _
        vbCrLf & vbCrLf & txt2 & _
        vbCrLf & vbCrLf & txt1

    ' Close the file if we opened it.
    If file_open Then Close #fnum
    Exit Sub
End Sub


