VERSION 4.00
Begin VB.Form GraphForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Graph"
   ClientHeight    =   4110
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   5790
   Height          =   4515
   Left            =   1080
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4110
   ScaleWidth      =   5790
   Top             =   1170
   Width           =   5910
   Begin VB.PictureBox picGraph 
      AutoRedraw      =   -1  'True
      Height          =   4095
      Left            =   0
      ScaleHeight     =   4035
      ScaleWidth      =   5715
      TabIndex        =   0
      Top             =   0
      Width           =   5775
   End
End
Attribute VB_Name = "GraphForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Values(1 To 10) As Single
' Draw the graph.
Private Sub DrawGraph()
Dim i As Integer
Dim dx As Single
Dim y0 As Single

    y0 = picGraph.ScaleHeight * 0.9
    dx = picGraph.ScaleWidth / 12

    ' Draw the bar chart.
    For i = 1 To 10
        picGraph.Line (i * dx, y0)-((i + 1) * dx, Values(i)), vbRed, BF
    Next i
    For i = 1 To 10
        picGraph.Line (i * dx, y0)-((i + 1) * dx, Values(i)), vbBlack, B
    Next i
End Sub

' Create some random data.
Private Sub LoadData()
Dim i As Integer
Dim min As Single
Dim max As Single

    Randomize

    min = picGraph.ScaleHeight * 0.1
    max = picGraph.ScaleHeight * 0.8
    For i = 1 To 10
        Values(i) = Int((max - min + 1) * Rnd + min)
    Next i
End Sub

' Generate some random data and draw the graph.
Private Sub Form_Load()
    ' Load some random data.
    LoadData
    
    ' Shade the background.
    ShadePicture

    ' Draw the graph.
    DrawGraph
End Sub
' Shade picGraph from white at the top to
' black at the bottom.
Private Sub ShadePicture()
Const START_COLOR = 255
Const END_COLOR = 0
Dim Y As Single
Dim clr As Single
Dim d_clr As Single
Dim scale_mode As Integer
Dim scale_left As Single
Dim scale_top As Single
Dim scale_width As Single
Dim scale_height As Single

    ' Save the current scale information.
    scale_mode = picGraph.ScaleMode
    If scale_mode = vbUser Then
        scale_left = picGraph.ScaleLeft
        scale_top = picGraph.ScaleTop
        scale_width = picGraph.ScaleWidth
        scale_height = picGraph.ScaleHeight
    End If

    ' Shade using pixels.
    picGraph.ScaleMode = vbPixels

    d_clr = (END_COLOR - START_COLOR) / picGraph.ScaleHeight
    clr = START_COLOR
    For Y = 0 To picGraph.ScaleHeight
        picGraph.Line (0, Y)- _
            (picGraph.ScaleWidth, Y), _
            RGB(clr, clr, clr)
        clr = clr + d_clr
    Next Y

    ' Restore the scale information.
    If scale_mode = vbUser Then
        picGraph.Scale (scale_left, scale_top)- _
            (scale_left + scale_width, _
            scale_top + scale_height)
    Else
        picGraph.ScaleMode = scale_mode
    End If
End Sub

