VERSION 4.00
Begin VB.Form DataTypeSummaryForm 
   Caption         =   "Data Type Summary"
   ClientHeight    =   3585
   ClientLeft      =   795
   ClientTop       =   1305
   ClientWidth     =   8895
   Height          =   3990
   Left            =   735
   LinkTopic       =   "Form1"
   ScaleHeight     =   3585
   ScaleWidth      =   8895
   Top             =   960
   Width           =   9015
   Begin VB.TextBox txtOutput 
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2895
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "DataTypeSummaryForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Get the next delimited token from the string txt.
Function GetToken(txt As String, delimiter As String) As String
Dim p As Integer

    ' Find the delimiter.
    p = InStr(txt, delimiter)

    ' Get the token.
    If p = 0 Then p = Len(txt) + 1
    GetToken = Left(txt, p - 1)

    ' See what's left of the string txt.
    p = Len(txt) - p + 1 - Len(delimiter)
    If p <= 0 Then
        txt = ""
    Else
        txt = Right(txt, p)
    End If
End Function

' Read the data file and close it.
Sub LoadData(fnum As Integer)
Const FORMAT_SPECIFIER = "!@@@@@@@@@@@@@@@@@@@@"

Dim output_txt As String
Dim all_data As String
Dim next_line As String
Dim token As String

    ' Read all the data.
    all_data = Input(LOF(fnum), #fnum)
    
    ' Start with column headers.
    output_txt = _
        Format("Data Type", FORMAT_SPECIFIER) & _
        Format("Size", FORMAT_SPECIFIER) & _
        Format("Approx Min", FORMAT_SPECIFIER) & _
        Format("Approx Max", FORMAT_SPECIFIER)
    output_txt = output_txt & vbCrLf & _
        Format("---------", FORMAT_SPECIFIER) & _
        Format("----", FORMAT_SPECIFIER) & _
        Format("----------", FORMAT_SPECIFIER) & _
        Format("----------", FORMAT_SPECIFIER) & _
        vbCrLf

    ' Read the lines from the file.
    Do While Len(all_data) > 0
        ' Get the next line.
        next_line = GetToken(all_data, vbCrLf)
    
        ' Break the line into pieces.
        Do While Len(next_line) > 0
            token = GetToken(next_line, ";")
            If Len(token) > 0 Then output_txt = output_txt & Format(token, FORMAT_SPECIFIER)
        Loop
        output_txt = output_txt & vbCrLf
    Loop

    ' Display the result.
    txtOutput = output_txt
End Sub

' Read the data from the data file.
Private Sub Form_Load()
Dim fnum As Integer

    ' Open the file.
    fnum = FreeFile
    Open App.Path & "\types.dat" For Input As fnum
    
    ' Read the data.
    LoadData fnum
End Sub

' Make txtOutput as large as possible.
Private Sub Form_Resize()
    txtOutput.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


