VERSION 5.00
Begin VB.Form CircleForm 
   AutoRedraw      =   -1  'True
   Caption         =   "Circles"
   ClientHeight    =   3825
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   3825
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   255
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   255
End
Attribute VB_Name = "CircleForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const err_INVALID_PARAMETER = vbObjectError + 11

' True if we are in the development environment.
Public DebugMode As Boolean

' See if we are running in the development environment
' or a compiled program. Run this routine at startup.
Public Sub SetDebugMode()
    On Error GoTo CompiledVersion

    ' If the program is compiled, the following
    ' Debug statement has been removed so it will
    ' not generate an error.
    Debug.Print 1 / 0
    DebugMode = False
    Exit Sub

CompiledVersion:
    ' We got an error so the Debug statement must
    ' be working.
    DebugMode = True
End Sub

' Verify that the variant is of the correct type.
Public Sub VerifyVariantType(param As Variant, _
    type_name As String, routine_name As String)

    If Not (TypeName(param) = type_name) Then
        If DebugMode Then
            Stop
        Else
            Err.Raise err_INVALID_PARAMETER, _
                "MyProgram." & routine_name, _
                "Parameter should be of type " & _
                type_name & _
                " but it is of type " & _
                TypeName(param) & _
                " with value " & param
        End If
    End If
End Sub

' Draw a series of concentric circles.
Private Sub DrawCircles(ByVal X As Single, ByVal Y As Single, _
    ByVal radius As Single, _
    Optional ByVal color As Long = vbBlack, _
    Optional ByVal aspect As Single = 1#)
Dim r As Integer

    ' Verify that 0.25 <= aspect ratio <= 4.
    If (aspect < 0.25) Or (aspect > 4) Then
        If DebugMode Then
            Stop
        Else
            Err.Raise err_INVALID_PARAMETER, _
                "Circles.DrawCircles", _
                "The aspect parameter must be between " & _
                " 0.25 and 4 but is " & aspect
        End If
    End If

    ' Draw the circles.
    r = radius
    Do While r >= 1
        Circle (X, Y), r, color, , , aspect
        r = r - 4
    Loop
End Sub
Private Sub Form_Load()
    ' See if we are in the developmeny environment.
    SetDebugMode
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    DrawCircles X, Y, 100
End Sub

