VERSION 4.00
Begin VB.Form DataTypeSummaryForm 
   Caption         =   "Data Type Summary"
   ClientHeight    =   3585
   ClientLeft      =   795
   ClientTop       =   1305
   ClientWidth     =   8895
   Height          =   3990
   Left            =   735
   LinkTopic       =   "Form1"
   ScaleHeight     =   3585
   ScaleWidth      =   8895
   Top             =   960
   Width           =   9015
   Begin VB.TextBox txtOutput 
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2895
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "DataTypeSummaryForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Get the next delimited token from the text buffer.
' Remove the token from the buffer.
Private Sub GetToken(ByRef txt_buffer As String, ByRef token As String, ByVal delimiter As String)
Dim delimiter_position As Integer
Dim new_length As Integer

    ' Find the delimiter.
    delimiter_position = InStr(txt_buffer, delimiter)

    ' Get the token and see what's left of txt_buffer.
    If delimiter_position = 0 Then
        ' The delimiter is not present.
        ' Use all of txt_buffer as the token.
        token = txt_buffer
        txt_buffer = ""
    Else
        ' The delimiter is present.
        ' Compute token and see what's left
        ' of txt_buffer.
        token = Left$(txt_buffer, delimiter_position - 1)
        new_length = Len(txt_buffer) - _
            delimiter_position + 1 - Len(delimiter)
        txt_buffer = Right$(txt_buffer, new_length)
    End If
End Sub

' Read the data file.
Private Sub LoadData(ByVal fnum As Integer)
Const FORMAT_SPECIFIER = "!@@@@@@@@@@@@@@@@@@@@"

Dim output_txt As String
Dim all_data As String
Dim line_data As String
Dim token_data As String

    ' Read all the data.
    all_data = Input$(LOF(fnum), #fnum)

    ' Start with column headers.
    output_txt = _
        Format("Data Type", FORMAT_SPECIFIER) & _
        Format("Size", FORMAT_SPECIFIER) & _
        Format("Approx Min", FORMAT_SPECIFIER) & _
        Format("Approx Max", FORMAT_SPECIFIER)
    output_txt = output_txt & vbCrLf & _
        Format("---------", FORMAT_SPECIFIER) & _
        Format("----", FORMAT_SPECIFIER) & _
        Format("----------", FORMAT_SPECIFIER) & _
        Format("----------", FORMAT_SPECIFIER) & _
        vbCrLf

    ' Read the lines from the file.
    Do While Len(all_data) > 0
        ' Get the next line.
        GetToken all_data, line_data, vbCrLf

        ' Break the line into tokens.
        Do While Len(line_data) > 0
            GetToken line_data, token_data, ";"
            If Len(token_data) > 0 Then
                output_txt = output_txt & _
                    Format(token_data, _
                    FORMAT_SPECIFIER)
            End If
        Loop
        output_txt = output_txt & vbCrLf
    Loop

    ' Display the result.
    txtOutput.Text = output_txt
End Sub

' Read the data from the data file.
Private Sub Form_Load()
Dim fnum As Integer

    ' Open the file.
    fnum = FreeFile
    Open App.Path & "\types.dat" For Input As fnum

    ' Read the data.
    LoadData fnum

    ' Close the file.
    Close fnum
End Sub

' Make txtOutput as large as possible.
Private Sub Form_Resize()
    txtOutput.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


