Attribute VB_Name = "ShowErr"
Option Explicit

' Display an error message. If the help file
' and context are available, allow the user to
' click the Help button.
Public Sub ShowErrorMessage(ByVal routine_name As String)
Dim txt As String

    ' Create the error message.
    txt = MakeErrorMessage(routine_name)

    ' Display with or without the help button
    ' as is appropriate.
    If DEBUG_MODE And Len(Err.HelpFile) > 0 Then
        MsgBox txt, _
            vbOKOnly + vbMsgBoxHelpButton, _
            "Unexpected Error", _
            Err.HelpFile, Err.HelpContext
    Else
        MsgBox txt, vbOKOnly, "Unexpected Error"
    End If
End Sub
' Make an appropriate error message.
Public Function MakeErrorMessage(ByVal routine_name As String) As String
    MakeErrorMessage = _
        "Encountered an unexpected error." & _
        vbCrLf & _
        "Please forward the following " & _
        "information to the development team." & _
        vbCrLf & vbCrLf & _
        "Error " & Format$(Err.Number) & _
        " in " & routine_name & "." & _
        vbCrLf & Err.Description
End Function
